/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\ INFO_BOX.C \\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\ SOURCE C du module de GESTION \\\\\\\\\\\\\\\\\\\*/
/*                    de la boite d'information                        */
/*                         du programme                                */
 
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*..................... INCLUDES DES AUTRES MODULES DU PROGRAMME ......*/
#include "EAZY_GEM.H"  /* inclure les definitions des fonctions que le */
                       /* que le module EAZY_GEM.C met  notre         */
                       /* notre disposition                            */
                       /* et inclure les definitions des variables     */
                       /* globales  EAZY_GEM                           */

#include "EZ_EDIT.SYS\INFO_BOX.RSH"  /* symboles du ressource          */

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  F O N C T I O N S \\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
CALLBACK WindProcInfo(int w_ind, EVNT_O *Evnt);

/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                   */
/*              Definition des fonctions de ce module                   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*------------------------------ WindProcInfo --------------------------*/
/* Affiche la boite d'information du programme                          */
CALLBACK WindProcInfo(int w_ind, EVNT_O *Evnt)
{/*....recuperer l'adresse du premier objet (racine) de la ressource....*/
 OBJECT *object = GETWINDTREE(w_ind); /* adr. arbre integre en fenetre  */
 int        w_h = Windtab[w_ind].w_h; /* handle GEM de notre fenetre    */
 /*.... recuperer handle fenetre avant plan (besoin apres)..............*/
 int wh_top;                    /* handle fenetre en avant plan         */
 wind_get( 0, WF_TOP, &wh_top); /* recuperer handle fen. avt plan.      */
 
 if (Evnt->evnt & MU_KEYBD && w_h==wh_top)
    {int i;
     char scan;  
     GRECT grect;          /* rectangle surface de travail              */
     grect = Windtab[w_ind].GemWorkGrect;
     scan  = (char)(Evnt->key>>8);
     switch(scan)
       {case  80:     /* down */
        case  72:     /* up   */
          if (Evnt->ksp & (K_RSHIFT|K_LSHIFT))
             {GetScrollBoxParam(object,LISEZMOI_SCROLL_BOX,0L,0L,0L,0L,0L,0L,0L,0L,0L,&i);
              if (scan!=80) i=-i;
              DoScrollBoxSlide (object, LISEZMOI_SCROLL_BOX,i,0,&grect);
              object[LISEZMOI_VERT_ASC].ob_y = VascPosAdjust(object, LISEZMOI_SCROLL_BOX, LISEZMOI_VERT_BAR, LISEZMOI_VERT_ASC); 
              Xobjc_draw(object, LISEZMOI_VERT_BAR, 1, &grect);
             }
          else 
             {if (scan==80) i= 1;
              else          i=-1;
              DoScrollBoxSlide (object, LISEZMOI_SCROLL_BOX,i,0,&grect);
              object[LISEZMOI_VERT_ASC].ob_y = VascPosAdjust(object, LISEZMOI_SCROLL_BOX, LISEZMOI_VERT_BAR, LISEZMOI_VERT_ASC);
              Xobjc_draw(object, LISEZMOI_VERT_BAR, 1, &grect);
             }
          break;
        case 71:     /* clr home  */
          if (Evnt->ksp & (K_RSHIFT|K_LSHIFT))
             {int nblt,    /* nbr de lignes total document                 */
                  nb_l;    /* nbr de lignes affichables par la scroll box  */
              GetScrollBoxParam (object, LISEZMOI_SCROLL_BOX,0L,0L,&nblt,0L,0L,0L,0L,0L,0L,&nb_l); 
              SetScrollBoxParam (object, LISEZMOI_SCROLL_BOX,-2,-2,-2,-2,nblt-nb_l,-2,-2,-2,(void*)-2L,-2);
             }
          else
             {SetScrollBoxParam (object, LISEZMOI_SCROLL_BOX,-2,-2,-2,-2,0,-2,-2,-2,(void*)-2L,-2);
             }
          object[LISEZMOI_VERT_ASC].ob_y = VascPosAdjust(object, LISEZMOI_SCROLL_BOX, LISEZMOI_VERT_BAR, LISEZMOI_VERT_ASC);
          Xobjc_draw(object, LISEZMOI_VERT_BAR, 1, &grect);  
          Xobjc_draw(object, LISEZMOI_SCROLL_BOX, 1, &grect);
          break;
       } /*end switch scan  */
    }
    
 if (Evnt->evnt & MU_BUTTON )
    {int ob_ret = Xform_button(w_ind, Evnt);
     if (ob_ret == LISEZMOI_SCROLL_BOX)
        {Evnt->evnt &= ~MU_BUTTON;   /* empecher propagation message  MU_BUTTON */
         /*............. si objet exit selectionne ...................*/
         object[ob_ret&0x7FFF].ob_state &= ~SELECTED;
         SendWindMessage(w_h, WM_CLOSED, 0L);
        }
    } /* endif MU_BUTTON  et fenetre au premier plan */

 if (Evnt->evnt & MU_TIMER && w_h==wh_top)  Xform_timer(w_ind, Evnt);
 if (Evnt->evnt & MU_MOVE)                  Xform_mu_move(w_ind, Evnt);
 if (Evnt->evnt & MU_MESAG)
    {switch (Evnt->pipe[MESG])
       {case WM_CONSTRUCT:
             if (WindDialogConstruct(w_ind, 
                                     LoadAppliRsc( "INFO_BOX.RSC", NO_SCALE), 0, RSC_DIAL, Evnt
                                    ) == WM_ABORT
                ) return WM_ABORT;     
             AdjustWindCoordToScreen (w_ind, Evnt, (GRECT*)&Evnt->pipe[X_B]);
             break;
        
       
        case WM_MOUSEWHEEL:       Xform_WheelButton(w_ind, Evnt, 3);                  break;
        case WM_DESTRUCT:         Xform_Destruct(w_ind, Evnt);    
                                  RscFicUnLoad(Windtab[w_ind].DlgVar.AdrRsc);         break;
        case WM_TT_ON_OFF:        SetBulleState(w_h, object);                         break;
        case WM_REDRAW:           Lister_rectangles(w_h,(GRECT*)&Evnt->pipe[X_G]);    break;
        case WM_BOTTOM:           wind_set(w_h, WF_BOTTOM );                          break;
        case WM_TOPPED:           wind_set(w_h, WF_TOP );                             break;
        case WM_CLOSED:           DestroyWindow(w_h);                                 break;
        case WM_ALLICONIFY:       AllIconify((GRECT*)& Evnt->pipe[X_G]);              break;
        case WM_ICONIFY:          IconifyWindow(w_ind, (GRECT*)& Evnt->pipe[X_G]);    break;
        case WM_UNICONIFY:        UnconifyWindow(w_ind);                              break;
        case WM_SIZED:
        case WM_MOVED:            Xform_moved(w_ind, Evnt);                           break;
       }
    }
 return Evnt->evnt;    /* retourner le flux evenementiel (modifie ou pas)    */
}
