/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\ EZ_EDIT.C \\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\ SOURCE   du module de GESTION \\\\\\\\\\\\\\\\\\\*/
/*                    d'une fenetre d'edition de                       */
/*                    texte C avec syntaxe colore                     */
/*              cet exemple montre comment synchroniser                */
/*              une SCROLLBOX avec un composant d'edition              */
/*              d'edition de texte.                                    */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ I N C L U D E S \\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
#include "EZ_EDIT.H"  /* routines d'affichage et de gestion du texte.  */
/*................ inclure les definitions generees par ...............*/
/*                 l'editeur de ressources afin d'utiliser             */
/*                 les symboles plutot que des nombres                 */
#include "EZ_EDIT.SYS\EZ_TXT.RSH"
#include "EZ_EDIT.SYS\CONFIG.RSH"
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\ D E F I N E S  \\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
#define FIC_MERGE  1
#define FIC_ISOPEN 2
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S    G L O B A L E S \\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\ V A R I A B L E S  P U B L I Q U E S \\\\\\\\\\\\\\\\\*/

SYNT_PARAM  *SyntPrmTab[NB_SYNT];
void *Gsc                 = 0;
void *GscPcStud           = 0;
char   **TxtPtStrMess     = 0;  /* pointera sur tableau de messages */
int  WIND_ID[NB_WDOC]; 
int  NbIDDoc              = 0;
int  CurIDDoc             = -1;     /* identificateur inexistant */
char IsCfgLoaded          = 0;
char PopMenWidth          = 37;
char CursorSpeed          = 5;
char IsViewFntReel        = 0;
char IsWindList           = 1;
char IsMarkList           = 1;
char IsFindAnim           = 1;
char IsIndexAnim          = 1;
char IsWcontrolOpen       = 1;
char WcontrolOngActif     = 2;     /* option base zero --> onglet int.Dep  */
GRECT wControlDefGrect    = {-1,-1,-1,-1};
char LastFicMustBeLoaded  = 0;
char LastCfgMustBeSaved   = 0;
char FicMustBeSavedOnQuit = 0;
char **EnvList            = 0;
int  LenFindStr           = 128;
int  PrtSizeFont          = 7;
char PrtFontName[40];             /* nom de la police pour imprimer */
int  ZoomX                = 100;
int  ZoomY                = 100;
int  DrvSel               = 0;
int  MrgLeft              = 100;   /* marge gauche en mm/10          */
int  MrgTop               = 0;     /* marge haute  en mm/10          */
int  MrgRight             = 0;     /* marge droite en mm/10          */
int  MrgBottom            = 0;     /* marge basse  en mm/10          */
int  VdiFntId             = 1;     /* Fonte Vdi pour imprimer        */
char PrtHead              = 1;     /* Imprimer entete de page?       */
char PrtNoteFoot          = 1;     /* Imprimer pied de page?         */
char IsPrtColor           = 1;     /* Imprimer en couleur?           */
char IsTidyManageError    = 1;     /* GEMTIDY manage les erreurs     */

long  LastHelpPos = -1;
char  LastHelpFic[MAX_PATH];
char *TxtRef      = 0;
char *TxtRep      = 0;
char  PathPCHelp[MAX_PATH];
char  PathPcStudio[MAX_PATH];
char  PathProject[MAX_PATH];
char  InclPath[MAX_PATH];                /* chemin du dossier include      */
char  PathTidy[MAX_PATH];
int   EZ_PG_DW  = 25641;
int   EZ_PG_UP  = 25384;

/*\\\\\\\\\\\\\\ V A R I A B L E S  I N T E R N E S \\\\\\\\\\\\\\\\\\\\\*/
char *PathVABuff     = 0;
void *AdrMessRSC     = 0;
void *AdrIconRSC     = 0;
size_t LenPathVABuff = MAX_PATH*2;
char PathAppli[MAX_PATH];
char PathTxt[MAX_PATH<<1];
char NomTxt[MAX_PATH];
int  AccMenID;  /* entree de menu octroyee lors demarrage en accessoire  */
char *FicNameErr    = "ERREUR.ERR";
char *FicNameErrOld = "ERREUR.OER";
extern TOOL_TIPS *TOOL_TPTAB;
 
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*\\\\\\\\\\\ P R O T O T Y P E S  D E  F O N C T I O N S \\\\\\\\\\\\\*/
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/

/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  P U B L I Q U E S \\\\\\\\\\\\\\*/
/*................Definies dans le Fichier: EZ_EDIT.C .................*/
int CreateNewTxtWindIdent(int *TabIdent, int nbIdent, int firstID);
void ReleaseTxtWindIdent( int ident, int *TabIdent, int nbIdent, int first_ID);
/*................ fonctions de fenetres de EZ_EDIT.C .................*/
CALLBACK WindProcDeskWind(int w_ind, EVNT_O *Evnt);
CALLBACK DefautCallbackProc(int w_ind, EVNT_O *Evnt);
/*\\\\\\\\\\\\\\\ P R O T O T Y P E S  I N T E R N E S \\\\\\\\\\\\\\\\*/
/*.............. petites fonctions pour faciliter la vie !! ...........*/
void   AdaptListBoxToWindHeight(int w_ind,int ob_list, int mincases, GRECT *ext_grect);
char  *ArgvPathToVA_START(const char *argv[], int nb_files);
int    LoadLastFic(void);
int    CfgWindParamToTexte(char *config, long test_token);
void   CfgWindTokenToWind(int w_ind, long token, char *pt_arg);
void   myGScommands( void *gsc, int argc, char **argv);
int    CutFile(char *path_in, char *name, char *ToCutAfter);
long   ReadLine(int fh, char *buf, long max_buf);
int    FindStr(char *pt, char *str_test);
char *GetLine(char *src, char *dst);
void   Spy(const char *mes);
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
/*                A   C O M M E N C E   I C I   !!!!                   */
/*              Definition des fonctions de ce module                   */
/*\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
 

/*---------------------------- main ------------------------------------*/
int main ( int argc, const char *argv[], const char *envp[] ) 
{EnvList = (char **)envp;
 InitMemMngr(TO_FILE);
 GSInit( myGScommands, 0L);
 Pdomain(1);
 GetPathAppli(PathAppli,  "EZ_EDIT.???", 0);
 /*.......... verifier si premier argument n'est pas le ................*/
 /*           fichier d'erreur. Si oui le renommer en .OLD              */
 /*           avant qu'EZ_EDIT s'en recree un nouveau                   */
 if (argc && argv[1]) 
    {strcpy(PathTxt, argv[1]);
     PathNomToNomFic(PathTxt, NomTxt);
     /*.......... si nom donn en entree est le fichier d'erreur .......*/
     if (strcmpi(PathTxt, PathAppli)   == 0 &&
         strcmpi(NomTxt,  FicNameErr)  == 0 &&
         Fic_exist(PathTxt, NomTxt)    >  0
        )
        {char *pt = GetExtension((char*)argv[1], 0);
         /*......... juste pour effacer un eventuel old .............*/
         SetErreurName(PathAppli, FicNameErrOld, ERR_ERASE);
         /*.......... renommer en .OLD ..............................*/
         strcpy(PathTxt,    NomTxt);
         strcat(PathAppli, FicNameErrOld);
         Frename(0, PathTxt, PathAppli);
         strcpy(pt,".OER");
        }
    }
 GetPathAppli(PathAppli,  "EZ_EDIT.???", 0);
 SetErreurName(PathAppli, FicNameErr, ERR_ERASE);
 /*
 OutErreur(PathAppli);
 OutErreur("erreur.err\r\n");
 */
 MAX_WIND  = NB_WDOC + 9; /* + alert, desk , Bookmark + config  + Popup + print + mess + Ez_ascii */
 /*MS_NB     = 1000;*/
 
 if (InitEazyGem("EZ_EDIT.???") != -1)
    {PathVABuff    = malloc(LenPathVABuff);
     *PathVABuff   = 0;
     *PathPcStudio = 0;
     *PathProject  = 0;
     strcpy(InclPath,"E:\\PURE_C\\INCLUDE\\");
     /*.............. chargement de la ressource de messages ...............*/
     AdrMessRSC   = LoadAppliRsc( "EZ_MESSG.RSC", NO_SCALE);
     if (AdrMessRSC>(void*)10) TxtPtStrMess = GetFreeStringTab(AdrMessRSC);   
     /*.............. chargement de la ressource icone iconification .......*/
     AdrIconRSC = LoadAppliRsc( "EZ_ICON.RSC", NO_SCALE);
     /*.............. chargement du fichier de configuration ...............*/
     if (CfgLoadDefaultConfig(AdrMessRSC)) IsCfgLoaded = 1;
     else                                  strcpy(IndexExt, TxtPtStrMess[PRM_IND_FIC]);
     if (Kbshift(-1) & 3)
        {int i=0;
         while(envp[i] && *envp[i])
            {Spy(envp[i]);
             i++;
            } 
        }
    
     /*.............. Mettre a zero le tableau des ID ......................*/
     /*                    de fenetre document                              */
     memset(WIND_ID, 0, NB_WDOC*sizeof(int));
     memset(SyntPrmTab,0,sizeof(SyntPrmTab));
     if (!_app)  
        {/*....... si demarre en accessoire installer le titre ds menu......*/
         /*               et attendre le message AC_OPEN                    */
         AccMenID = menu_register( Appl_id,TxtPtStrMess[REG_MENU_NAME]);
        }
     else
        {/*......... on va envoyer un faux message AC_OPEN .................*/
         /*            afin d'ouvrir d'emble la fenetre                    */
         int msgbuf[8];   
         AccMenID     = 12345;      /*   creer une entree de menu fantaisie   */
         msgbuf[MESG] = AC_OPEN;    /*   nature du message                    */
         msgbuf[APPL] = Appl_id;    /*   iddentificateur de l'appelant (moi)  */
         msgbuf[SUPL] = 0;          /*   message sans surplus                 */
         msgbuf[4]    = AccMenID;   /*   placer entree de menu declenchante   */
         appl_write(Appl_id, 16, msgbuf );
        }
     /*.................... Passer la main  EAZY_GEM ....................*/
     if (AccMenID != -1) 
        {/*........Noter chemin d'ou a ete lance le programme .....*/
         /*        et envoyer un message VA_START si le            */
         /*     programme est demarre avec un nom de fichier       */
         /*         de faon  demarrer avec ce fichier            */
         if (argc && argv[1]) 
            {ArgvPathToVA_START(argv + 1, argc - 1);
             GetPathAppli(PathAppli, NomAppli, 0);
            }
         else 
            {GetPathAppli(PathAppli, NomAppli, PathVABuff);
             if (strncmp(PathVABuff, "ARGV=", 5)==0) *PathVABuff = 0;
             else
                {char *pt       = strchr(PathVABuff, '.'); 
                 if (pt && strcmpi(pt,".PRG")==0) *PathVABuff = 0;
                }
            } 
         if (*PathVABuff)
            {LastCfgMustBeSaved = 0;
             IsWcontrolOpen     = 0;
             Send_VA_START(Appl_id, PathVABuff);
            }
         strcpy(PathIndex, PathAppli);
         strcpy(NomIndex, "INDEX.TXT");
         if (IsWcontrolOpen)
            {ActiveInfoWindow(WcontrolOngActif);
            }
         BouclePrincipale(DefautCallbackProc);  
        }     
     if (PathVABuff) free(PathVABuff);
     if (AdrIconRSC) RscFicUnLoad(AdrIconRSC);
     if (AdrMessRSC > (void*)10) RscFicUnLoad(AdrMessRSC);
     if (TxtRef)   free (TxtRef);
     if (TxtRep)   free (TxtRep);
    {int i;
     for (i=0; i<NB_SYNT; i++)
        {if (SyntPrmTab[i]) free(SyntPrmTab[i]);
        }
    }
    }
 /*........... appel indispensable pour finir un programme ...............*/
 /*                       EZ_GEM proprement                               */
 if (Gsc)
    {GSSendCommand( Gsc, "hasClosed",1, "");
     GSClose(Gsc);
    }
 if (GscPcStud)
    {GSSendCommand( GscPcStud, "hasClosed",1, "");
     GSClose(GscPcStud);
    }
 
 GSExit();
 ExitEasyGem();
 return 0;
}

/*----------------------------- myGScommands -----------------------------*/
void myGScommands( void *gsc, int argc, char **argv) 
{
 argc++; /* ne pas avoir "Parameter 'argc' is never used in function..." */
    if( !stricmp( argv[0],       "getappversion"))
        GSSetCommandResult( gsc, "1.00");
    else if( !stricmp( argv[0],  "getapplongname"))
        GSSetCommandResult( gsc, "EZ_EDIT: editeur multisyntaxique");
    else if( !stricmp( argv[0],  "quit"))
        SendMessage(AP_TERM);
    else if( !stricmp( argv[0], "reload"))
       {int wind = IsThisTxtLoaded(argv[1], 0);
        strcpy(PathVABuff, argv[1]);
        if (ExeTxtFunc(wind, TXT_RELOAD))
            GSSetCommandResult (gsc, "reload bien reu par EZ_EDIT: action ralise: fichier recharg");
        else
            GSSetCommandResult (gsc, "reload bien reu par EZ_EDIT: mais le fichier n'existe pas");
       }
    else if( !stricmp( argv[0], "open"))
       {char *path = malloc(strlen(argv[1])+4);
        if (path)
           {strcpy(path, argv[1]);
            PlaceQuote(path, 0);
            Send_VA_START(Appl_id, path);
            GSSetCommandResult (gsc, "open bien reu par EZ_EDIT: action ralise");
            free(path);
           }
       }
     else if( !stricmp( argv[0], "openErrFile"))
       {char *path = malloc(strlen(argv[1])+4);
        if (path)
           {strcpy(path, argv[1]);
            if (/*CutFile(path, 0, "errors were found")*/1);
               {PlaceQuote(path, 0);
                Send_VA_START(Appl_id, path);
               }
            free(path);
           }
        GSSetCommandResult (gsc, "openErrFile bien reu par EZ_EDIT: action ralise");
       }
    else if( !stricmp( argv[0], "OpenProject"))
       {GSSetCommandResult (gsc, "OpenProject bien reu par EZ_EDIT");
        strcpy(PathProject, argv[1]);
        ExeTxtFunc(0, TXT_PRJ_SET);
        Mouse_on();
       }
    else if( !stricmp( argv[0], "SetCursAtAbsPos"))
       {char path[MAX_PATH];
        char nom[MAX_PATH];
        strcpy(path, argv[1]);
        PathNomToNomFic(path, nom);
        if (LoadTxtInWind(path, nom, atol(argv[2]), GOTO_OPENWIND|ABS_POS))
                GSSetCommandResult (gsc, "SetCursAtAbsPos bien reu par EZ_EDIT: action ralise: fichier charg");
        else
                GSSetCommandResult (gsc, "SetCursAtAbsPos bien reu par EZ_EDIT: mais le fichier n'existe pas");
        Mouse_on();
       }
    else if( !stricmp( argv[0], "toFront"))
       {int wind = IsThisTxtLoaded(argv[1], 0);
        if (wind==-1)
           {char path[MAX_PATH];
            char nom[MAX_PATH];
            strcpy(path, argv[1]);
            PathNomToNomFic(path, nom);
            if (LoadTxtInWind(path, nom, 0, GOTO_OPENWIND))
               GSSetCommandResult (gsc, "toFront bien reu par EZ_EDIT: action ralise: fichier charg");
            else
               GSSetCommandResult (gsc, "toFront bien reu par EZ_EDIT: mais le fichier n'existe pas");
           }
        else
           {int wh_top;
            int w_h = GETGEMHAND(wind);
            wind_get( 0, WF_TOP, &wh_top);
            if (wh_top != w_h) 
               {SendWindMessage(w_h, WM_TOPPED, &Windtab[wind].GemWorkGrect);
               }
            GSSetCommandResult (gsc, "toFront bien reu par EZ_EDIT: action ralise: fentre au TOP");
           }
       }
    else if( !stricmp( argv[0], "setCursorAt"))
       {char path[MAX_PATH];
        char nom[MAX_PATH];
        strcpy(path, argv[1]);
        PathNomToNomFic(path, nom);
        if (LoadTxtInWind(path, nom, Max(0, atol(argv[3])-1), GOTO_OPENWIND))
                GSSetCommandResult (gsc, "setCursorAt bien reu par EZ_EDIT: action ralise: fichier charg");
        else
                GSSetCommandResult (gsc, "setCursorAt bien reu par EZ_EDIT: mais le fichier n'existe pas");
        Mouse_on();
       }
    else
        GSSetCommandResult( gsc, "EZ_EDIT: ne supporte pas cette commande");
}

/*---------------------------- CutFile --------------------------------*/
int CutFile(char *path_in, char *name, char *toCutAfter)
{int  f_src, f_dst;
 char path[MAX_PATH];
 char buf[1024];
 char *pt_ext;
 char ext[32];
 long ret;
 strcpy(path, path_in);
 if (name) strcat(path, name);
 /*........... rajouter eventuel retour chariot ...................*/
 pt_ext = GetExtension(path, ext);
 strcpy(pt_ext, ".TMP");
 ret = 0;
 if (Fic_exist(path, 0)>-1L)
    {ret = Fdelete(path);
    }
 if (ret != 0)                            return 0;    /* erreur dans effacement fichier    TMP */
 f_dst = (int) Fcreate(path, 0 );
 if (f_dst<0)                             return 0;    /* erreur dans ouverture destination TMP */
 strcpy(pt_ext, ext);
 f_src = (int)Fopen( path, FO_READ);
 if (f_src<0){Fclose(f_dst);              return 0;}    /* erreur dans ouverture source          */
 do{
    ret =  ReadLine(f_src, buf, 1023);
    if (ret)
       {if (FindStr(buf, toCutAfter))
           {Fwrite(f_dst, strlen(buf), buf );
            Fclose(f_dst);
            Fclose(f_src);
            Fdelete(path);
            strcpy(buf, path);
            strcpy(pt_ext, ".TMP");
            Frename(0, path, buf);
            return 1;
           }
        else
           {Fwrite(f_dst, strlen(buf), buf );
           }
       }
   }while (ret>=2);
 Fclose(f_dst);
 Fclose(f_src);
 return 0;
}
/*----------------------------- FindStr -----------------------------*/
int FindStr(char *pt, char *str_test)
{long len_test = strlen(str_test);
 while(*pt && *pt != '\r' && *pt != '\n')
      {if (strncmp(pt, str_test, len_test)==0) return 1;
       pt++;
      }
 return 0;
}
/*------------------------------- ReadLine -------------------------------*/
/* ACTION: lit une ligne dans le fichier fh et la place dans buf jusqu'a  */
/*         rencontrer une fin de ligne. Saute toutes les autre fins de    */
/*         ligne places  la suite. Et rajoute un \r\n en fin de buf     */
/* ENTREE: int fh: handle du fichier dan lequel lire.                     */
/*         char *buf: buffer dans lequel placer les octets.               */
/*         long max_buf: longueur maxi du buffer.                         */
/* SORTIE: 0/la fin du fichier est atteinte et buf est vide               */
/*         1/la fin du fichier est atteinte et buf contient la der ligne  */
/*         sinon NB de caracteres ecris dans buf                          */

long ReadLine(int fh, char *buf, long max_buf)
{long len_line = 0;
 long  nb_read = 0;
 char *pt      = buf;
 char buf_dumy[1];
 /*......... lire un octet ................*/
 do{*pt      = 0;
    nb_read  = Fread(fh, 1, pt );
    /*....si fin de ligne retourner .......*/
    if (*pt=='\r' || *pt=='\n') 
       {strcpy(pt, "\r\n");
        len_line  = pt - buf + 2;
        *buf_dumy = 0;
        /*....... avant de retourner sauter tous les \r\n ........*/
        do {nb_read = Fread(fh, 1, buf_dumy);
           }while ( nb_read>0 && (*buf_dumy=='\r' || *buf_dumy=='\n') );
        if (nb_read==0) return 1;
        Fseek(-1, fh, 1 );
        return len_line;
       }
    pt++;
   }while (nb_read>0 && pt-buf<max_buf);
 *pt      = 0;
 len_line = pt - buf;
 return 0;
}
/*-------------------------------- ArgvPathToVA_START --------------------*/
/* ACTION: cree une chaine VA_START  partir des arguments d'entree de la */
/*         chaine argv[]. les zero de fin sont remplaces par des espaces  */
/*         et les chaines d'argument linkes las unes aux autres.         */
/*         VA_SART est eventuellement realou.                            */
/* ENTREE: const char *argv[]  pointe sur le premier parametre valide.    */
/*                             (nom du premier fichier)                   */
/*         int nb_files          nombre de chaines a evaluer.             */
/* SORTIE: char *   adresse eventuellement realoue de la chaine VA_START */
char *ArgvPathToVA_START(const char *argv[], int nb_files)
{/*................ calculer memoire pour buffer .........*/
 int i;
 long len  = 0;
 char *end = 0;
 char *pt;
 /*...... calculer la taille necessaire  PathVABuff .....*/
 for (i=0; i<nb_files; i++) len += strlen(argv[i]) + 4; 
 len +=2;
 ReallocPathAVBuffer(len);
 /*........... linker les chaines ........................*/
 /*            en les plaant entre quote                 */
 pt  = PathVABuff;
 end = PathVABuff + LenPathVABuff;
 for (i=0; i<nb_files; i++)
     {len     = strlen(argv[i]);
      if (pt + len + 2 > end) break; /* si plus de place dans VA_START cassos */
      *pt     = '\'';
      pt++;
      memcpy(pt, argv[i], len);  pt += len;
      *pt     = '\'';  pt++;
      *pt     = ' ';   pt++;
     }
 if (nb_files) pt[-1] = 0;
 /*BlkCheck(0,0, PathVABuff, 1, __LINE__, __FILE__);*/
 return PathVABuff;
}

/*----------------------------- ReallocPathAVBuffer ----------------------*/
char *ReallocPathAVBuffer(long size)
{char *pt;
 /*...... reallouer nouveau PathVABuff si trop petit .....*/
 if (size > LenPathVABuff) 
    {pt = realloc(PathVABuff, size);
     if (pt) {LenPathVABuff = size;
              PathVABuff    = pt;
             }
     else    {pt = malloc(size);
              if (pt==0) {  return 0;}
              else       {memcpy(pt, PathVABuff, LenPathVABuff); /* BlkCheck(0,0, PathVABuff, 1, __LINE__, __FILE__); */
                          LenPathVABuff = size;
                          free(PathVABuff);
                          PathVABuff = pt;
                         }
             }
    }
 return pt;
}

/*----------------------------- DefautCallbackProc -----------------------*/
CALLBACK DefautCallbackProc(int w_ind, EVNT_O *Evnt)
{/*..........................Rpondre aux messages MU_MESAG .................*/
 /* L'vnement MU_MESAG se manifeste chaque fois qu'EAZY_GEM demande       */
 /* la fonction de CALLBACK de rpondre  un message. ci_dessous nous allons */
 /* rpondre aux messages d'ouverture et de fermeture de l'accessoire.       */
  if (Evnt->evnt & MU_KEYBD)
    {if (Evnt->ksp == K_CTRL)
        {switch(Evnt->key&0x00FF)
          {case 0X17:         /*  CTRL  W   */
             ExeTxtFunc(w_ind, DESK_WIND_CYCLE);
             Evnt->evnt &= ~MU_KEYBD;
             break;
           case 0X11:         /* CTRL Q     */
             ExeTxtFunc(w_ind, DESK_QUIT);
             Evnt->evnt &= ~MU_KEYBD;
             break;
          } /* endswitch(Evnt->key)        */
        } /* endif (Evnt->ksp == K_CTRL) */
    } /* endif (Evnt->evnt & MU_KEYBD) */
    
 if (Evnt->evnt & MU_MESAG)
    {switch (Evnt->pipe[MESG])
       {case AP_TERM:
             ExeTxtFunc(w_ind, DESK_QUIT);
             break;
        case WM_ISTOP:
             
             break;
        case AC_OPEN:
             if (Evnt->pipe[4] == AccMenID)
                {char *pt;
                 /*......... crer et Ouvrir les fenetres ................*/
                  pt = strchr(PathVABuff,'.');
                  if (pt && strcmp(pt,".PRG")==0) *PathVABuff=0;
                  if (*PathVABuff==0 )
                     {if (LastFicMustBeLoaded && IsCfgLoaded && LoadLastFic())
                         {
                         }
                      else if (ChargerFichiers()==0) EZGemRun = -1;
                     }
                 }
             break;
             
        case AC_CLOSE:
             if (Evnt->pipe[3] == AccMenID)
                {w_ind = IsWindExist(W_TXT_DESK); 
                 if (w_ind>-1) SendWindMessage(GETGEMHAND(w_ind), WM_CLOSED, 0);
                }
             break; 
        case AP_DRAGDROP:
             /**************************************************************/
             /*........................ AP_DRAGDROP (GEM message)..........*/
             /* Ce message est envoy a notre procedure de fenetre lorsque */
             /* un truc a t drag (tir) sur sa fenetre.                 */
            {long recept_type      =  0; /* type de donnes reues         */
             char *data            =  0;
             data = (char*)GetDragDropData(Evnt->pipe[7],0, 0, &recept_type, "ARGS.TXT.ASCURLS");

             if (data && recept_type=='ARGS')
                {long len_data      = strlen(data+4);
                 int wh_targ        = wind_find(Evnt->x, Evnt->y);
                 int wind_targ      = WindHandToIndice(wh_targ);
                 int ident          = GETWINDIDENT(wind_targ);
                 char *pt           = data + 4; 
                 char *pt_end       = data + len_data;
                 int          flag  = 0; 
                 int          wind  = 0;
                 long sav_mouseform = GetMouseForm();
                 SetMouseForm(BUSYBEE);
                 /*....... separer les arguments par des zeros de fin .............*/
                 Parse_ARGS(data+4);
                 /*................................................................*/
                 
                 if ( wind_targ >= MAX_WIND || !IS_IDWINDTXT(ident))  ident = -1;
                 if (Evnt->ksp & K_LRSHIFT && ident > -1) flag = FIC_MERGE;
                 if (flag == FIC_MERGE) OpenTxtInWind(ident, pt, 0, flag);
                 else
                    {while(pt<pt_end) 
                          {if (Verifie_ext(pt, ".bnf")||Verifie_ext(pt, ".bfn")||Verifie_ext(pt, ".BFN")) 
                              {strcpy(PathProject, pt);
                              }
                           if (IsThisExtensionIndex(GetFileExtension(pt, 0), IndexExt)
                              )
                              {ActiveInfoWindow(1);   /* (base0) deuxieme onglet = log. out  */
                               ExeAllMessage();
                               ExeAllMessage();
                               ExeAllMessage();
                               ExeAllMessage();
                               ExeAllMessage();
                               ExeAllMessage();
                               if (IsWindExist(W_EZ_INFO) != -1 &&
                                   WcontrolOngActif==1
                                  ) 
                                  {AddIndex(pt, 0, INDEX_MERGE);
                                  }
                              }
                           else
                              {
                               wind = IsThisTxtLoaded(pt, "");
                               /*......... si deja present on recharge avec ...........*/
                               /*          le fichier deja present                     */
                               if (wind>-1)
                                  {OpenTxtInWind(GETWINDIDENT(wind), pt, 0, 0);
                                  }
                               /*....... sinon on ouvre un editeur ....................*/   
                               else
                                  {OpenTxtInWind(-1, pt, 0, 0);
                                  }
                              }
                           /*......... chercher nouvel argument ...........*/
                            while(*pt && pt<pt_end) pt++; pt++;   /* passer le zero  */
                          }
                    }
                 if (data) free(data);
                 SetMouseForm(sav_mouseform);
                }  /* endif (len_data)  */
              else if (data && (recept_type=='.TXT' ||
                                recept_type=='.ASC' ||
                                recept_type=='URLS'
                               )
                      )
                {long x        = Evnt->x;
                 long y        = Evnt->y;
                 int wind_targ = WindHandToIndice( wind_find((int)x, (int)y));
                 if (wind_targ<MAX_WIND)
                    {int ident = GETWINDIDENT(wind_targ);
                     if (IS_IDWINDTXT(ident))
                        {int param[8];
                         TXTED_OB* TXT_A    = WTXT_A(wind_targ);
                         char *txt          = EZ_ED_GetLigCol(XY_TO_LIGPT, &y, &x, TXT_A);
                         *(long*) &param[0] = (long)txt+x;    /* pointe sur texte ou on doit placer le curseur  */
                         *(long*) &param[2] = (long)TXT_A;    /*  W_G H_G  adresse de l'editeur cible           */
                         EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_SET_CURS_POS, param, 4, TXT_A);
                         *(long*) &param[0] = (long)data+4;     /*  path du fichier a merger                    */
                         *(long*) &param[2] = (long)TXT_A;    /*  W_G H_G  adresse de l'editeur cible           */
                         EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_MEMORY_PASTE, param, 4, TXT_A);
                        }
                    }
                 if (data) free(data);
                }
             else if (data) free(data);
             }  /* endbloc case AP_DRAGDROP: */
             break; 
        case VA_START:          /*  (XGEM message)   */          
             /**************************************************************/
             /*........................ VA_START (GEM message).............*/
             /* Le message VA_START est envoy par une autre application   */
             /* pour demander  la notre de s'activer (il faut bien sur    */
             /* qu'elle ait ete auparavant ete chargee en memoire)         */
             /* exemple dans un systeme multitache notre application est   */
             /* en sommeil, avec toutes ses fenetres en arriere plan et    */
             /* il lui est demandee de s'activer (en general pour charger  */
             /* un fichier ou toute autre chose)                           */
             /* Exemple on a double clique sur un fichier lie  notre appli*/
             /* a partir du bureau, ou on a pose un fichier sur notre appli*/
             /* ou tout simplement double clique sur l'icone de notre appli*/
             /* sans fichier ou ...                                        */
            {
             int msgbuf[8];
             char *pt           = 0;
             char *va_txt       = (char*)(*(long*)&Evnt->pipe[3]); /* pointe sur chaine VA_START  */
             int   wind         = 0;
             long sav_mouseform = GetMouseForm();
             SetMouseForm(BUSYBEE);
             
             /*........... recuperer chaine VA_START ...............................*/
             /*
             pt       = strchr(va_txt, '.'); 
             if (pt && strcmpi(pt,".PRG")==0) 
                {va_txt = "E:\\PURE_C\\EZ_EDIT\\EZ_EDIT.LOG";
                }
             */
             
             if (va_txt && *va_txt)
                {int i;
                 int nb_arg;
                 if (*va_txt=='-')
                    {if (va_txt[1]=='d')
                        {int w_inf = IsWindExist(W_EZ_INFO);
                         /*printf("VA_START reu:%s",va_txt);*/
                         ActiveInfoWindow(101); /* premier onglet = log. out  */
                         ExeAllMessage();
                         ExeAllMessage();
                         ExeAllMessage();
                         ExeAllMessage();
                         ExeAllMessage();
                         ExeAllMessage();
                         if (IsWindExist(W_EZ_INFO) != -1 &&
                             WcontrolOngActif==1
                            ) 
                            {AddString(w_inf, va_txt+3, 0);
                            }
                        }
                     *va_txt=0;
                     Evnt->evnt &= ~MU_MESAG;
                     SetMouseForm(sav_mouseform);
                     return Evnt->evnt;
                     /*goto VASTART_AKCNW;*/
                    }
                 /*........... exploiter le message VA_START ...........................*/
                 nb_arg = Parse_ARGS(va_txt);
                 pt     = va_txt;
                 /*OutMessage(va_txt); OutMessage("\r\n");*/
                 for (i=0; i<nb_arg; i++)
                   {if (Verifie_ext(pt, ".bnf")||Verifie_ext(pt, ".bfn")||Verifie_ext(pt, ".BFN")) 
                       {strcpy(PathProject, pt);
                       }
                    else if (IsThisExtensionIndex(GetFileExtension(pt, 0), IndexExt) )
                       {int w_inf = IsWindExist(W_EZ_INFO);
                        int activ = 1;
                        /*....... si fichier vide ou inexistant ...............*/
                        /*      n'activer que si fenetre ouverte               */
                        /*      pour un eventuel effacement                    */
                        if (Fic_exist(pt,0)<=0 && w_inf==-1) activ = 0;
                        if (activ)
                           {ActiveInfoWindow(101); /* premier onglet = log. out  */
                            ExeAllMessage();
                            ExeAllMessage();
                            ExeAllMessage();
                            ExeAllMessage();
                            ExeAllMessage();
                            ExeAllMessage();
                            if (IsWindExist(W_EZ_INFO) != -1 &&
                                WcontrolOngActif==1
                               ) 
                               {AddIndex(pt, 0, INDEX_MERGE);
                               }
                           } /*endif (activ) */
                       } /*endif (IsThisExtensionIndex(GetFileExtension(pt, 0), IndexExt) ) */
                    else
                       {wind = IsThisTxtLoaded(pt, "");
                        if (wind>-1)
                           {OpenTxtInWind(GETWINDIDENT(wind), pt, 0, FIC_ISOPEN);
                           }
                        else
                           {OpenTxtInWind(-1, pt, 0, 0);
                           }
                       }
                    /*......... chercher nouvel argument ...........*/
                     while(*pt) pt++; pt++;   /* passer le zero  */
                   } 
                }  
                /*............ SI chaine VA_START vide c'est que l'on ................*/
                /*          a double clique sur l'icone du programme                  */
                /*          sans fichier donc activer notre programme                 */
                /*          en mettant par exemple nos fenetres au TOP (premier plan) */
                /*          et en activant notre menu                                 */ 
             else                             
                {int i;
                 for (i=0; i<MAX_WIND; i++) /* activer nos fenetres si elles existent */
                     {if (Windtab[i].w_flag & W_IS_ICON || 
                          Windtab[i].w_flag & W_IS_ALLICON
                         )
                         {UnconifyWindow(i); 
                         }
                      else if (Windtab[i].w_h>-1) 
                               SendWindMessage(Windtab[i].w_h, WM_TOPPED, &Windtab[i].GemWorkGrect); /*wind_set(Windtab[i].w_h,WF_TOP); */
                     }                                      
               }
             /*VASTART_AKCNW:*/
             /*............ renvoyer accus de reception VA_START...................*/
             /*    la chaine VA_START est liberee  la suite de cet appel           */
             /*    par l'application serveur (emettrice du message VA_START)        */
             msgbuf[MESG]=VA_AKCNW;           /*   accuse de reception  VA_START    */
             msgbuf[APPL]=Appl_id;            /*   iddentificateur de l'appelant    */
             msgbuf[SUPL]=0;                  /*   message sans surplus             */
             msgbuf[3]=Evnt->pipe[3];         /*   il faut retourner l'adresse de   */
             msgbuf[4]=Evnt->pipe[4];         /*   la chaine c'est comme a !!      */
             appl_write(Evnt->pipe[APPL], 16, msgbuf );  /* on envoie le paquet     */
             SetMouseForm(sav_mouseform);
            }      /* end case VA START   */     
             break;
       }
    }         
 return Evnt->evnt;    /* retourner le flux evenementiel (modifie ou pas)    */
}

/*------------------------------ LoadLastFic --------------------------------*/
int LoadLastFic(void)
{char path[MAX_PATH];
 long   len_cfg = 0;
 char *config   = 0;
 char       *pt = 0;
 int          n = 0;
 long      line = 0;
 long     token = 0;
 GRECT    grect, *ptgrect;
 GetPathRsc(AdrMessRSC, path);
 PathNomToNomFic(path, 0);
 len_cfg = Fic_exist(path, TxtPtStrMess[PRM_CFG_NAME]);
 if (len_cfg<10) return 0;
 config  = malloc(len_cfg+2);
 if (config==0) return 0;
 Bload(path, TxtPtStrMess[PRM_CFG_NAME], config);
 config[len_cfg] = 0;
 /*............. analyse et mise a jour de la ressource ..................*/
 pt = config;
 while (*pt)
  {pt=GoFirstValid(pt, " \n\r\t");
   if      (*pt==';') {pt = NextLine(pt);line++;}
   else if (*pt=='[' && pt[1])
      {pt= GoFirstValid(pt+1, " \t");
       /*........ si valeur numerique l'extraire ...................*/
       if (*pt>='0' && *pt<='9')
          {while(*pt && (*pt>='0' && *pt<='9')) pt++;
          }
       /*........ relever les 4 premiers caracteres du token .......*/
       memcpy(&token,pt,4); 
       pt = NextBreakChar(pt, "]\n\r");
       pt = GoFirstValid(pt+1, " \t");
       /*........ sortir si erreur .................................*/
       if (*pt==0|| pt[1]==0) break;
       /*......... relever l'eventuel rectangle d'ouverture ........*/       
       if (token=='_Win')
          {char *end         = NextBreakChar(pt, ";\n\r"); /* chercher fin de ligne     */
           char sav          = *end;                       /* placer un zero de fin     */
           char *pt_arg      = pt;
           char buft[MAX_PATH];
           *end              = 0;
           pt_arg = GetArgument(pt_arg, buft);
           if (*buft ) grect.g_x = atoi(buft);
           pt_arg = GetArgument(pt_arg, buft);
           if (*buft ) grect.g_y = atoi(buft);
           pt_arg = GetArgument(pt_arg, buft);
           if (*buft ) grect.g_w = atoi(buft);
           /*......... on ne valide le rectangle de creation .......*/
           /*          de fenetre que si il est complet             */
           pt_arg = GetArgument(pt_arg, buft);
           if (*buft ) 
              {grect.g_h = atoi(buft);
               ptgrect   = &grect;
              }
           else ptgrect      = 0;
           *end              = sav;
          }
       /*......... executer le token en question ...................*/
       else if (token=='_Las')
          {char sav;
           char *end = NextBreakChar(pt, ";\n\r");     /* chercher fin de ligne     */
           while (end>pt && (end[-1]==32||end[-1]=='\t')) end--;
           sav  = *end;                                /* placer un zero de fin     */
           *end = 0;
            if (Fic_exist(pt, "")>-1 && (OpenTxtInWind(-1, pt, ptgrect, 0) != -1) ) n++;
           *end = sav;                             /* restaurer la fin de ligne */
          }
       pt = NextLine(pt);
       line++;
      }
   else 
      {char buft[MAX_PATH];
       strcpy(buft,TxtPtStrMess[ALR_CFG_ERR1]);
       strcat(buft,ltoa(line,"                 ",10));
       strcat(buft,TxtPtStrMess[ALR_CFG_ERR2]);
       form_alert(0,buft);
       break;
      }
  }  /* end  while (*pt)  */
 /*............. placer les parametres de chaque fenetre .................*/
 CfgWindParamToTexte(config, '_Boo');
 CfgWindParamToTexte(config, '_Cur');
 free (config);
 return n;
}

/*------------------------------ CfgWindParamToTexte ---------------------*/
int CfgWindParamToTexte(char *config, long test_token)
{char *pt       = config;
 int          n = 0;
 long      line = 0;
 long     token = 0;
 int wind       = GetFirstWindTxt(); 
 while (*pt)
  {pt=GoFirstValid(pt, " \n\r\t");
   if      (*pt==';') {pt = NextLine(pt);line++;}
   else if (*pt=='[' && pt[1])
      {pt= GoFirstValid(pt+1, " \t");
       /*........ si valeur numerique l'extraire ...................*/
       if (*pt>='0' && *pt<='9')
          {char *end = pt;
           char sav;
           while(*end && (*end>='0' && *end<='9')) end++;
           sav  = *end; *end = 0;
           n    = atoi(pt);
           *end = sav;
           pt   = end;  /* on ne considere le token qu'apres les chiffres */
          }
       /*........ relever les 4 premiers caracteres du token .......*/
       memcpy(&token,pt,4); 
       pt = NextBreakChar(pt, "]\n\r");
       pt = GoFirstValid(pt+1, " \t");
       /*........ sortir si erreur .................................*/
       if (*pt==0|| pt[1]==0)    break;
       /*......... executer le token en question ...................*/
       else if (token==test_token && wind>-1)
          {char *end         = NextBreakChar(pt, ";\n\r"); /* chercher fin de ligne     */
           char sav          = *end;                       /* placer un zero de fin     */
           *end              = 0;
           CfgWindTokenToWind( wind, token, pt);
           *end = sav;                             /* restaurer la fin de ligne */
           wind = GetNextWindTxt(wind);
           n++;
          }
       pt = NextLine(pt);
       line++;
      }
   else 
      {char buft[MAX_PATH];
       strcpy(buft,TxtPtStrMess[ALR_CFG_ERR1]);
       strcat(buft,ltoa(line,"                 ",10));
       strcat(buft,TxtPtStrMess[ALR_CFG_ERR2]);
       form_alert(0,buft);
       break;
      }
  }  /* end  while (*pt)  */
 return n;
}

/*------------------------------ CfgWindTokenToWind ---------------------*/
void CfgWindTokenToWind(int w_ind, long token, char *pt_arg)
{char buft[MAX_PATH];
 long param[2];
 TXT_GFG *ptTxtCfg = WTXT_CFG(w_ind);
 TXTED_OB  *TXT_A  = WTXT_A(w_ind);
 if (w_ind<=-1)                         return;
 if (token=='_Boo')
    {int i;
     for (i=0; i<10; i++)
         {pt_arg = GetArgument(pt_arg, buft);
          if (*buft ) ptTxtCfg->Bookmark[i] = Min(atol(buft), (long)(TXT_A->EndTxt - TXT_A->ptTxt));
         }
    }
 else if (token=='_Win')
    {GRECT grect,scrgrect;
     pt_arg = GetArgument(pt_arg, buft);
     if (*buft ) grect.g_x = atoi(buft);
     pt_arg = GetArgument(pt_arg, buft);
     if (*buft ) grect.g_y = atoi(buft);
     pt_arg = GetArgument(pt_arg, buft);
     if (*buft ) grect.g_w = atoi(buft);
     pt_arg = GetArgument(pt_arg, buft);
     if (*buft ) grect.g_h = atoi(buft);
     wind_get(0,4,&scrgrect.g_x, &scrgrect.g_y, &scrgrect.g_w, &scrgrect.g_h);
     AdjustGrectToGrect(&scrgrect, &grect);
     ExeWindMessage(w_ind, WM_SIZED, (int*)&grect, 4);
     /*SetWindowSize(w_ind, &grect);*/
    }    
 else if (token=='_Cur')
    {long curs_pos, blk_deb, blk_end;
     curs_pos = blk_deb = blk_end = -1L;
     pt_arg = GetArgument(pt_arg, buft);
     if (*buft ) curs_pos = Min((long)TXT_A->EndTxt, atol(buft)+(long)TXT_A->ptTxt);
     pt_arg = GetArgument(pt_arg, buft);
     if (*buft ) blk_deb  = Min((long)TXT_A->EndTxt, atol(buft)+(long)TXT_A->ptTxt);
     pt_arg = GetArgument(pt_arg, buft);
     if (*buft ) blk_end  = Min((long)TXT_A->EndTxt, atol(buft)+(long)TXT_A->ptTxt);
     if (blk_deb != blk_end && blk_end != -1L && blk_deb != -1L)
        {param[0] = blk_deb;  
         param[1] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
         TXT_A->State  |= EDIT_HIDE;
         EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, (int*)param, 4, TXT_A);
         EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_CLEAR_SEL,    (int*)param, 4, TXT_A);
         EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_DEB,  (int*)param, 4, TXT_A);
         param[0] = blk_end;
         EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_SEL_END,  (int*)param, 4, TXT_A);
         TXT_A->State  &= ~EDIT_HIDE;
        }
     if (curs_pos != -1L)
        {param[0] = curs_pos;  
         param[1] = (long)TXT_A;                 /*  W_G H_G  adresse de l'editeur cible       */
         TXT_A->State  |= EDIT_HIDE;
         EZ_ED_DirectExeEditMessage(w_ind, EXE_ED_SET_CURS_POS, (int*)param, 4, TXT_A);
         TXT_A->State  &= ~EDIT_HIDE;
        }
    }
}

/*------------------------------ IsThisExtensionIndex -------------------*/
char *IsThisExtensionIndex(char *ext, char *extlist)
{char *pt = extlist;
 char arg[32]; 
 if (ext==0 || *ext==0) return 0;
 while (pt && *pt)
       {char *find;
        find = pt;
        pt   = GetArgument(pt, arg);
        if (*arg && strcmpi(ext, arg)==0 ) return find;
       }
 return 0;
}

/*------------------------------ GetFileExtension -----------------------*/
char *GetFileExtension(char *path, char *nom)
{char *pt;
 char *pt_str;
 /*........ si un nom est fourni rechercher extension chez lui ..........*/
 /*         sinon on recherche l'extension dans le path                  */
 if (nom && *nom) pt_str = nom;
 else             pt_str = path;

 if ((pt=strrchr(pt_str,'.'))!=0) return pt;
 else                             return 0;
}

/*------------------------------ ChargerFichiers ------------------------*/
int ChargerFichiers(void)
{char *pt_files; 
 pt_files = XFilesSelect(PathTxt, NomTxt,".*",TxtPtStrMess[MESS_LOAD_TXT],0);
 if (pt_files)
    {Send_VA_START(Appl_id, pt_files);
     free(pt_files);
     return 1;
    }
  return 0;
}

/*---------------------- OpenTxtInWind ----------------------------------*/
int OpenTxtInWind(int ident, char *path, GRECT *grect, int flag)
{int wind_targ;
 GRECT scrgrect;
 long sav_mouseform = GetMouseForm();

 /*............ ajuster rectangle d'entree ........................*/
 if (grect)
    {wind_get(0,4,&scrgrect.g_x, &scrgrect.g_y, &scrgrect.g_w, &scrgrect.g_h);
     AdjustGrectToGrect(&scrgrect, grect);
     grect->g_h = Min(scrgrect.g_h, grect->g_h);
     grect->g_w = Min(scrgrect.g_w, grect->g_w);
    }
 /*............ activer fenetre texte .............................*/
 ident = ActiveWindowTexte(ident, 0x8000|SMALLER|CLOSER|NAME|MOVER|XMOVER|XBORDER|XSIZER|FULLER,
                                  path, grect,
                                  WindTxtWind);
 if (flag&FIC_ISOPEN)       return  ident;
 /*............ si tout est OK charger le nouveau texte ...........*/
 wind_targ  = IsWindExist(ident);
 if (wind_targ >= -1 && IS_IDWINDTXT(ident))
    {OBJECT *object    = GETWINDTREE(wind_targ);
     TXTED_OB* TXT_A   = WTXT_A(wind_targ);
     int wh_targ       = GETGEMHAND(wind_targ);
     TXT_GFG *ptTxtCfg = WTXT_CFG(wind_targ);
     
     if (flag & FIC_MERGE && Fic_exist(path, "") > 0)
        {int param[4];
         *(long*) &param[0] = (long)path;               /*  path du fichier a merger                  */
         *(long*) &param[2] = (long)TXT_A;              /*  W_G H_G  adresse de l'editeur cible       */
         strcpy(ptTxtCfg->PathBlk, path);
         PathNomToNomFic(ptTxtCfg->PathBlk, ptTxtCfg->NomBlk); 
         EZ_ED_DirectExeEditMessage(wind_targ, EXE_ED_FILE_PASTE, param, 4, TXT_A);
         SetTxtChgIndicator(wind_targ, 1);
        }                         
     else if (Fic_exist(path, "") > 0)
        {strcpy(ptTxtCfg->PathTxt, path);
         PathNomToNomFic(ptTxtCfg->PathTxt, ptTxtCfg->NomTxt);
         SetMouseForm(BUSYBEE);
         /*.............. charger le fichier de parametrage ............................*/
         /*               syntaxique li au fichier (si il existe)                      */
         ptTxtCfg->SyntPrm    = SyntaxConfigure(ptTxtCfg->NomTxt);
         if (ptTxtCfg->SyntPrm) 
            {/*........ le fichier de parametrage syntaxique peut ......................*/
             /*          aussi comporter des parametres generaux                        */
             int OldIntl = TXT_A->IntLg;
             CfgParamToTexte ( wind_targ, &ptTxtCfg->SyntPrm->HeadTxt, &ptTxtCfg->SyntPrm->TxtPrm, ptTxtCfg->SyntPrm);
             if (OldIntl != TXT_A->IntLg)
                {SetScrollBoxParam(object, EZ_TXT_SCLBOX, TXT_A->IntLg,-2,-2,-2, -2, -2, -2,-2,(void*)-2L,-2);
                 UpdateParamTexte(object,  EZ_TXT_SCLBOX, WTXT_A(wind_targ));
                 VascHeightAdjust(object,  EZ_TXT_SCLBOX, EZ_TXT_VERT_BAR, EZ_TXT_VERT_ASC);
                }
            }
         else
            {object[EZ_TXT_COLOR_SYNT].ob_flags |= HIDETREE;
             EZ_ED_SetDrawLineFunc(0L, TXT_A);
            }
         if (EZ_ED_LoadTxt(wind_targ, ptTxtCfg->PathTxt, ptTxtCfg->NomTxt, TXT_A))
            {int wh_top;          
             wind_get( 0, WF_TOP, &wh_top);          /* celui de fenetre avant plan  */
             strcpy(Windtab[wind_targ].titre + 1, ptTxtCfg->PathTxt);
             strcat(Windtab[wind_targ].titre + 1, ptTxtCfg->NomTxt);
             *Windtab[wind_targ].titre = ' ';
             if (Windtab[wind_targ].w_attr & NAME) wind_set( wh_targ, WF_NAME, Windtab[wind_targ].titre); 
             /*SendObjectRedraw(wh_targ, object, EZ_TXT_SCLBOX);*/
             object[EZ_TXT_CHG_INDIC].ob_flags |= HIDETREE;
             /*if (wh_targ != wh_top) SendObjectRedraw(wh_targ, object, EZ_TXT_CHG_INDIC);
             else                   Wobjc_draw(wind_targ, object, EZ_TXT_CHG_INDIC, 1, 0);
             */
            }
         SetMouseForm(sav_mouseform);
        }
    }                  
 return  ident ;
}

/*------------------------------ MultiFicToVA_START ---------------------*/
/* ACTION: compose                                                       */
char *MultiFicToVA_START(char *path, char *pt_files)
{int nb_files = 1;
 int i;
 size_t len;
 size_t accu_len;
 size_t len_path = strlen(path);
 char *pt        = pt_files;
 char *pt_end;
 char *ptAV;
 if (pt_files==0)                                                  return 0;

 /*................ compter nombre de fichiers ...........*/
 while(*pt){if (*pt==' ') nb_files++; pt++;}
 /*................ calculer memoire pour buffer .........*/
 len = (pt - pt_files) + 2 + (len_path+2) * nb_files;
 /*...... reallouer nouveau PathVABuff si trop petit .....*/
 if (len > LenPathVABuff) 
    {pt = realloc(PathVABuff, len);
     if (pt) {LenPathVABuff = len;
              PathVABuff    = pt;
             }
    }
 /*...... creer autant de path complets que de fichiers ....*/
 pt       = pt_files;
 pt_end   = 0;
 accu_len = 0;
 ptAV     = PathVABuff;
 for (i=0; i<nb_files; i++)
     {pt_end = strchr(pt,' ');
      if (pt_end) {len = pt_end - pt; }
      else        {len = strlen(pt); pt_end = pt + len;} 
      
      accu_len             += len_path + len + 1;
      if (accu_len >= LenPathVABuff) break;
      memcpy(ptAV, path, len_path);        ptAV += len_path;
      memcpy(ptAV, pt,   len +1);          ptAV += len + 1;  /* +1 pour zero de fin ou espace */
      pt += len +1;
     }
 *ptAV = 0; 
 /* BlkCheck(0,0, PathVABuff, 1, __LINE__, __FILE__); */
 return PathVABuff;
}

/*---------------------- AdaptListBoxToWindHeight -----------------------*/
void AdaptListBoxToWindHeight(int w_ind,int ob_list, int mincases, GRECT *ext_grect)
{GRECT  wgrect;
 int i,oby0,oby,h_lign,nbcases,nbitem,first;
 OBJECT *object = GETWINDTREE(w_ind);
/*.............. Adapter hauteur des LISTBOX ..............................*/
 WindGemBorderToEZWork(Windtab[w_ind].w_attr, ext_grect, &wgrect);
 objc_offset(object,ob_list,&i,&oby);   /* recuperer position y de la list box   */
 objc_offset(object,0,&i,&oby0);        /* recuperer position y de l'objet zero  */
 oby -= oby0;                              /* ofset par rapport espace de travail   */
 
 GetListBoxParam(object,ob_list,0,&first,0,&nbitem,&h_lign,0);
 mincases = Min(mincases,nbitem+1);
 oby      = wgrect.g_h - oby - 5;  
 nbcases  = oby / h_lign;
 nbcases  = Max(2,Min(nbcases,mincases));
 first    = Min(nbitem-nbcases,first);
 SetListBoxParam(object, ob_list,-2,first,nbcases,-2,-2,(void*)-2);
}


/*-------------------------- ActiveWindow ----------------------------------*/
void ActiveWindow(int ident, long attr, char *title, CALLBACK (*w_proc)(int w_ind, EVNT_O *Evnt))
{int w_ind;
 w_ind = IsWindExist(ident);
 if (w_ind==-1)                 /* << SI existe pas la creer         */
    { int w_h = CreateWindow(0x8000|attr, ident,0L,w_proc, 0,20+((Ecran_h-20)>>1),Ecran_l,(Ecran_h-20)>>1, title);
      if (w_h==-3||w_h==-2) form_alert(1,TxtPtStrMess[ALR_NOWIND_MORE]);
    }
 else                           /* << SI elle existe                  */
    {if (Windtab[w_ind].w_flag & W_IS_ICON || 
         Windtab[w_ind].w_flag & W_IS_ALLICON
        )
        {UnconifyWindow(w_ind); 
        }
     else if (IsWindOpen(w_ind))     /*        SI ouverte la mettre au top */
        {wind_set(Windtab[w_ind].w_h,WF_TOP);
        }
     else                       /*        SI pas ouverte l'ouvrir     */
        {OpenWindow(w_ind, &Windtab[w_ind].ExtGrectUse);
        } 
    } 
}

/*-------------------------- ActiveWindowTexte -----------------------------*/
int ActiveWindowTexte(int ident, long attr, char *title, GRECT *ptgrect, CALLBACK (*w_proc)(int w_ind, EVNT_O *Evnt))
{int w_ind,w_desk;
 int w_h;
 w_ind = IsWindExist(ident);
 if (w_ind==-1)                 /* << SI existe pas la creer         */
    {ident      =  CreateNewTxtWindIdent(WIND_ID, NB_WDOC, W_FIRST_DOC);    
     if (ident>-1) 
        {GRECT grect;
         grect.g_x = 0;
         grect.g_y = 20+((Ecran_h-20)>>1);
         grect.g_w = Ecran_l;
         grect.g_h = (Ecran_h-20)>>1;
         w_desk    = IsWindExist(W_TXT_DESK);
         if (w_desk != -1) 
            {grect.g_y = Windtab[w_desk].ExtGrectUse.g_y;
             grect.g_h =Ecran_h-20 - grect.g_y;
            }
         /*.......... si un rectangle est donne  en entree ...............*/
         /*           utiliser  ses coordonnees                           */
        
         w_h = CreateWindow(0x8000|attr, ident, ptgrect, w_proc, grect.g_x, grect.g_y, grect.g_w, grect.g_h, title);
         if (w_h>0)
            {int w_ind         = WindHandToIndice(w_h);
             TXT_GFG *ptTxtCfg = WTXT_CFG(w_ind);
             w_ind             = WindHandToIndice(w_h);
             strcpy(ptTxtCfg->PathTxt, title);
             PathNomToNomFic(ptTxtCfg->PathTxt, ptTxtCfg->NomTxt); 
             strcpy(Windtab[w_ind].titre + 1,   ptTxtCfg->PathTxt);
             strcat(Windtab[w_ind].titre + 1,   ptTxtCfg->NomTxt);
             *Windtab[w_ind].titre = ' ';
             if (Windtab[w_ind].w_attr & NAME) wind_set( w_h, WF_NAME, Windtab[w_ind].titre); 
                                                                       return ident;
            }
         else if (w_h==-3 || w_h ==-2) form_alert(1,TxtPtStrMess[ALR_NOWIND_MORE]);
        }
     else
        {ReleaseTxtWindIdent(ident, WIND_ID, NB_WDOC, W_FIRST_DOC); 
        }
    }
 else                           /* << SI elle existe                  */
    {w_h = GETGEMHAND(w_ind);
     if (Windtab[w_ind].w_flag & W_IS_ICON || 
         Windtab[w_ind].w_flag & W_IS_ALLICON
        )
        {UnconifyWindow(w_ind); 
         SendWindMessage(w_h, WM_TOPPED, &Windtab[w_ind].GemWorkGrect);
                                                                        return ident;
        }
     else if (IsWindOpen(w_ind))     /*        SI ouverte la mettre au top */
        {int wh_top;
         wind_get( 0, WF_TOP, &wh_top);
         if (wh_top != w_h) 
            {SendWindMessage(w_h, WM_TOPPED, &Windtab[w_ind].GemWorkGrect);
                                                                        return ident;
            }
         else
                                                                        return CurIDDoc;
        }
     else                       /*        SI pas ouverte l'ouvrir     */
        {OpenWindow(w_ind, &Windtab[w_ind].ExtGrectUse);
                                                                        return CurIDDoc;
        } 
    } 
 return -1;
}


/*----------------------------- GetSourceFromBFN ------------------*/
/*   FNC_LIST_C;    ".FNC"                                         */
/*   FNC_LIST_CC;   ".FCC"                                         */
/*   FNC_LIST_P;    ".FPC"                                         */
/*   FNC_LIST_H;    ".FHC"                                         */
/*   FNC_LIST_S;    ".FNS"                                         */
int GetSourceFromBFN(char *path, char* nom, int flag)
{char arg[MAX_PATH];
 char def_path[MAX_PATH];
 char *pt_ext;
 char *adr, *pt;
 long nb_file;
 long len_fic;
 
 /*........ relever fichier BFN  charger ..............*/
 if (*PathProject==0)                         return 0;
 strcpy(def_path, PathProject);
 pt_ext = GetExtension(def_path, 0);
 
 /*......... normaliser l'extension ....................*/
 if (pt_ext) 
    {if (!(strcmpi(pt_ext,".bfn")==0||
           strcmpi(pt_ext,".bnf")==0
          )
        )
     strcpy(pt_ext, ".BFN");
    }
 else        strcat(def_path,   ".BFN");
 len_fic   = Fic_exist(def_path,0);
 if (len_fic<=0)                              return 0;
 adr = LoadFic(def_path);
 if (adr==0)                                  return 0;
 if (strncmp(adr,"PcsBase",7))                return 0;
 /*.......... path de chargement du fichier .BFN .......*/
 /*           est le path par defaut                    */
 PathNomToNomFic(def_path, 0);
 /*................ path va nous servir de buffer ......*/
 
 pt      = adr;
 pt      = GetLine(pt, arg);        /* passer "PcsBase"          */
 pt      = GetLine(pt, arg);        /* recuperer nbr de fichier  */
 nb_file = atol(arg);
 if (nb_file==0) {free(adr);                  return 0;}
 Enleve_ext(nom);
 if      (flag & FNC_LIST_C)  { pt_ext = ".C";   flag &= ~FNC_LIST_C;   }
 else if (flag & FNC_LIST_CC) { pt_ext = ".CC";  flag &= ~FNC_LIST_CC;  }
 else if (flag & FNC_LIST_H)  { pt_ext = ".H";   flag &= ~FNC_LIST_H;   }
 else if (flag & FNC_LIST_P)  { pt_ext = ".CPP"; flag &= ~FNC_LIST_P;   }
 else if (flag & FNC_LIST_S)  { pt_ext = ".S";   flag &= ~FNC_LIST_S;   }
 else                           pt_ext = ".C";

 strcat(nom, pt_ext);                                                   
 pt      = GetLine(pt, arg);        /* recuperer path            */
 StrTrimEnd(arg);
 strcpy(path, arg);
 while(nb_file>0)
    {pt      = GetLine(pt, arg);     /* recuperer premier nom de fichier      */
     StrTrimEnd(arg);                /* lui enlever espaces de fins           */
     PathCat(def_path, path, arg);   /* former le chemin reel (derelativiser) */
     PathNomToNomFic(def_path, arg); /* recuperer nom du fichier              */
     
     if (strcmpi(nom, arg)==0)
        {strcpy(path, def_path);
         strcpy(nom,  arg);
         free(adr);
         return flag;
        }
     nb_file--;
    }
 
 free(adr);
 return 0;
}
/*----------------------------- ProjectFind -----------------------*/
/* typedef struct {char SepBeg[2];
                   char PtFunc[10];
                   char SepNum[2];
                   char NameVar[64];
                   char Numfile[6];
                   char End[2];
                  }VAR_RECORD;
*/

int ProjectFind(char *txt, char* path_in, char *path_find, long *pt_find)
{char arg[MAX_PATH];
 char def_path[MAX_PATH];
 char *pt_ext;
 char *adr, *pt;
 long nb_file;
 char *pt_file;
 long len_fic;
 char *pt_end;
 char *pt_deb;
 VAR_RECORD  *var_record;
 VAR_RECORD  *last_record;
 /*........ relever fichier BFN  charger ..............*/
 if (*PathProject==0)                         return 0;
 if (path_in==0||*path_in==0)
    {strcpy(def_path, PathProject);
    }
 else
    {strcpy(def_path, path_in);
    }
 pt_ext = GetExtension(def_path, 0);
 
 /*......... normaliser l'extension ....................*/
 if (pt_ext) 
    {if (!(strcmpi(pt_ext,".bfn")==0||
           strcmpi(pt_ext,".bnf")==0
          )
        )
     strcpy(pt_ext, ".BFN");
    }
 else        strcat(def_path,   ".BFN");
 len_fic   = Fic_exist(def_path,0);
 if (len_fic<=0)                              return 0;
 adr = LoadFic(def_path);
 if (adr==0)                                  return 0;
 if (strncmp(adr,"PcsBase",7))                return 0;
 /*.......... path de chargement du fichier .BFN .......*/
 /*           est le path par defaut                    */
 PathNomToNomFic(def_path, 0);

 /*................ path va nous servir de buffer ......*/
 
 pt      = adr;
 pt      = GetLine(pt, arg);        /* passer "PcsBase"          */
 pt      = GetLine(pt, arg);        /* recuperer nbr de fichier  */
 nb_file = atol(arg);
 if (nb_file==0) {free(adr);                  return 0;}
/*....... sauter path par defaut du fichier.............*/
/*         (dont on ne se sert pas)                     */
 pt      = GetLine(pt, arg);
 pt_file = pt;
 pt     += nb_file*MAX_PATH;
 var_record   = (VAR_RECORD*)pt;
 last_record  = (VAR_RECORD*)( (long)adr + len_fic);
 while (var_record<last_record)
    {char *ptext = var_record->NameVar;
     ptext[63]=0; 
     StrTrimEnd(ptext);
     ptext = strstr(ptext, "::");
     if (ptext==0) ptext = var_record->NameVar;
     if (strstr(ptext, txt))
        {long num_file;
         char sav;
         var_record->PtFunc[9]=0;   
         StrTrimEnd(var_record->PtFunc);
         var_record->Numfile[5]=0;  
         StrTrimEnd(var_record->Numfile);
         num_file = atol(var_record->Numfile);
         /*....... chercher la fin du nom de fichier ...............*/
         /*        et la fermer par un zero de fin                  */
         pt_deb   =  pt_file + num_file*MAX_PATH;
         pt_end   =  pt_deb  + 254;
         while(pt_end > pt_file && pt_end[-1]==' ') pt_end--;
         sav = *pt_end; *pt_end=0;
         /*...... si path par defaut le rajouter ......................*/
         PathCat(path_find, def_path, pt_deb);
         *pt_end       = sav;    /* restaurer le car original */
         *pt_find      = atol(var_record->PtFunc);
         free(adr);
         return 1;
        }
     var_record++;
    }
 free(adr);
 return 0;
}

/*----------------------------- InListFuncFind ---------------------------------*/
int InListFuncFind(char* to_find, char*  path_in, char* nom_in, long* pt_find)
{char path[MAX_PATH];
 char* pt_ext;
 long  len;
 char *adr;
 int flag;
 VAR_RECORD  *var_record;
 VAR_RECORD  *last_record;
 
 strcpy(path, path_in);
 if (nom_in)  strcat(path, nom_in);
 pt_ext     = GetExtension(path, 0);
 if (pt_ext==0)  pt_ext = path + strlen(path);
 /*........ recuperer les bons chemins ......*/
 /*         o ont ete places les .FNC       */
 /*         selon si .S ou .C                */
 if (pt_ext)
    {if      (strcmpi(pt_ext, ".s")==0)   {strcpy(pt_ext,   ".FNS"); flag = FNC_LIST_S;}
     else if (strcmpi(pt_ext, ".c")==0)   {strcpy(pt_ext,   ".FNC"); flag = FNC_LIST_C;}
     else if (strcmpi(pt_ext, ".cc")==0)  {strcpy(pt_ext,   ".FCC"); flag = FNC_LIST_CC;}
     else if (strcmpi(pt_ext, ".cpp")==0) {strcpy(pt_ext,   ".FPC"); flag = FNC_LIST_P;}
     else if (strcmpi(pt_ext, ".h")==0)   {strcpy(pt_ext,   ".FHC"); flag = FNC_LIST_H;}
     else                                 {strcpy(pt_ext,   ".FNC"); flag = FNC_LIST_C;}
    }
 len          = Fic_exist(path, 0);   if (len<=0)       return -1;
 adr          = LoadFic(path);        if (adr==0)       return -1;
 var_record   = (VAR_RECORD*)adr;
 last_record  = (VAR_RECORD*)( (long)adr + len);
 len          = strlen(to_find);
 
 while (var_record<last_record)
    {if (strncmp(var_record->NameVar,to_find, len)==0)
        {var_record->PtFunc[9]=0;   
         StrTrimEnd(var_record->PtFunc);
         *pt_find      = atol(var_record->PtFunc);
         free(adr);
         return flag;
        }
     var_record++;
    }
 free(adr);
 return -1;
}


/*----------------------------- PathCat ---------------------------------*/
/* ACTION: concatene les deux morceaux de path en entre, et si il y a   */
/*         des chemin relatifs, les transforme en chemin reel.           */
/*                                                                       */
/* ENTREE: char *dst: endroit ou le resultat doit etre place.            */
/*         char *path: chemin complet, partant de la racine, etant le    */
/*                     chemin dans lequel l'on doit trouver: nom.        */
/*                     SI nom est complet alors: path sera ignor car il */
/*                            sera considr deja tout pret.             */
/*                     Si Path est suivi d'un nom de fichier, celui ci   */
/*                             sera enleve de path.                      */
/*         char *nom: nom du fichier  concatener au path. Ce nom peut   */
/*                    etre entier en partant de la racine et auquel cas  */
/*                    il sera considr comme complet et non concatn   */
/*                    path.                                              */
/*                    Notez que nom peut commencer par \PATH ou PATH     */
/*                    indiffrement. La fonction s'arrange.              */
/* SORTIE: char* qui pointe sur dst.                                     */

char *PathCat(char *dst, const char *path, const char* nom)
{char buf[MAX_PATH<<1];
 char *pt;
 char *prev_fold;
 char is_root = 0;
 /*........ si un des chemins n'est pas de la racine cassos .............*/
 if (path[1]!=':' && nom[1]!=':')
    {printf("ERREUR PathCat(): au moins un des chemins doit partir de la racine");
     return dst;
    }
 /*....... creer chaine de commande avec path du texte a editer........*/
 if (nom[1]==':') 
    {strcpy(dst, nom);
    }
 else 
    {strcpy(dst, path);
     PathNomToNomFic(dst, 0);
     if (*nom=='\\')  strcat(dst, nom+1);/* rajouter argument          */
     else             strcat(dst, nom);  /* rajouter argument          */
    }
 /*........... normaliser les chemin relatifs .........................*/
 NormaliseRelativPath( buf, dst, MAX_PATH<<1);
 /*......... si il y a des chemins relatifs les supprimer .............*/
 pt = buf;
 while(*pt)
    {if (*pt=='.' && pt[1]=='\\' ) /* normalement \..\                 */
        {if (is_root==0)
            {prev_fold = pt-1;   /* reculer avant le premier point     */
             /*......... reculer avant \ du folder precedent           */
             if (prev_fold[-1] == '\\' && 
                 prev_fold>buf
                ) 
                {prev_fold--;   /* c'est celui de fin     */
                }
             /*...... reculer jusqu'au dossier avant ..................*/
             while(prev_fold>buf)
              {if  (prev_fold[-1]=='\\') break;
               prev_fold--;
              }
             /*...... noter si on a atteint le path racine .................*/
             if (prev_fold[-2]==':') is_root = 1;
            }  /* endif (is_root==0) */
         else
            {printf("ERREUR PathCat(): impossible de reculer avant la racine ");
            }
         /*....... deplacer les chaines ....................................*/
         pt += 2;        /* se placer apres le \                            */
         memmove(prev_fold, pt, strlen(pt)+1); /* embarquons le zero de fin */
         pt = prev_fold;
        }
     else  /* endif (*pt=='.' && pt[1]=='\\' ) */
        {pt++;
        }
    }  /*end while(*pt) */
 strcpy(dst, buf);
 return dst;
}

/*---------------------- NormaliseRelativPath ------------------------------*/
/* ACTION: examine le chemin et si trouve: -> un ..\  ou....\  les          */
/*                                            normalise  ..\               */
/*                              si trouve: -> un .\ (repertoire courant)    */
/*                                            normalise  \                 */
/* RETOUR: long: longueur de la chaine normalise zero de fin non compris   */

long NormaliseRelativPath( char *dst, char *src, long size_buf)
{char *pt      = src;
 char *deb_dst = dst;
 char *end_buf = dst + size_buf;  /* pour que: strcpy(dst, "..\\") depasse pas */
 while(*pt && dst<end_buf)
   {if (*pt=='.')
       {char *pt_slash = strchr(pt,'\\');  /* cas  .\ ou ...\ ou .. */
        if (pt_slash && pt_slash-src == 1) /* cas.\ repertoire courant */
           {pt++;
           }
        else if (pt_slash && pt_slash[-1]=='.'&& dst + 3 < end_buf)
           {strcpy(dst, "..\\");
            pt   = pt_slash + 1;
            dst += 3;
           }
        else                               /* cas  MACHIN.BOF          */
           {*dst = *pt;
             pt++;
             dst++;
           }
        }
    else                                   /* tout autre caractre     */
        {*dst = *pt;
          pt++;
          dst++;
        }
   }  /*endwhile(*pt && dst<end_buf) */
 *dst=0;
 return dst - deb_dst;
}

/*-------------------------- GetLine --------------------------------*/
char *GetLine(char *src, char *dst)
{while (*src && *src != '\r' && *src != '\n')
    {*dst = *src;
     src++;
     dst++;
    }
 *dst=0;
 if        (*src=='\r' && src[1]=='\n') src += 2;
 else if   (*src=='\r' || *src=='\n')   src += 1;
 return src;
}

/*--------------------------- LoadFic ----------------------------------*/
char *LoadFic(const char *path)
  {INT16  f_hand;
   long  f_len = 0;
   char  *adr  = 0;
   if ( (f_hand = (INT16) Fopen( path, FO_READ)) >= 0)
      {f_len = filelength(f_hand);
       if (f_len==0) return 0;
       adr = malloc(f_len+1+MAX_PATH);
       if (adr==0)   return 0;
       Fread(f_hand, f_len, (char*)adr);
       Fclose (f_hand);
       adr[f_len]=0;
      }
   return adr;
  }



void Spy(const char *mes)
{puts("\33H");
 printf("%s","                                                                                                                                                                 ");
 puts("\33H");
 printf("%s",mes);
 getch();
}
